package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Slave
// Camp: Civilians

class Slave extends Civilian {
	def static order = 12;
	def static strings = Civilian.strings.attachBundle("roles/Slave.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = false;	// All roles must define own "bite" property.
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	Slave(actor = null) {
		super(actor);
	}
	def getPriority() {
		return 20;
	}
	def getRoleName() {
		return strings.getString("slave");
	}
	// Notifies the actor of the role.
	def noticeRole() {
		super.noticeRole();
		def actors = JinroGame.getActors();
		actors.findAll{ it.roleIs(new Noble()) }.each {
			notice(strings.getString("notice.master", it.name, JinroGame.getAlias(new Noble().getRoleName())));
		}
	}
	// Judges victory or defeat.
	// if the result is... 0: civilians win, 1: wolves win, 2: foxes win
	def judge(result) {
		if(result == 0) {
			def actors = JinroGame.getActors();
			def nobles = actors.find { it.isLive() && it.roleIs(new Noble()) };
			if(!nobles) {
				return true;
			}
		}
		return false;
	}
}
